
//Copyright (C) 1998-2018 MKTMK Moscow, Russia
//http://sourceforge.net/projects/obasic/
//http://mktmk.narod.ru
//e-mail: mktmk<at>yandex.ru
//e-mail: openbasicsoft<at>gmail.com
//interpreter Open Basic (OB).

#include <ob.h>

namespace OB_NAMESPACE_FOR_OB {

	//here is function depend on OB_USER_WCHAR flag

#ifdef OB_USER_WCHAR

	void wchar2char(ob_type_string_char_small* sfn, ob_type_char* name) {
		ob_type_stringsize l = ob_strlen(name);
		sfn->recount(l);
		if (wcstombs(sfn->c_str(), name, l) == -1) OB_ERR(ob_err82)
	}

	void char2wchar(ob_type_string* sfn, ob_type_small_char* name) {
		ob_type_stringsize l = ob_strlen_small(name);
		sfn->recount(l);
		if (mbstowcs(sfn->c_str(), name, l) == -1) OB_ERR(ob_err83)
	}

#endif

	//conversion wchar stream to char stream for wchar version
	//for example create wchar name and load it to ob_lex as input stream
	//or for ob_obasic::load

	void ob_wstream_to_stream(ob_type_shortstrstream* datastream, ob_type_standartstring* st) {

		ob_type_size_t l = st->length() * sizeof(ob_type_char);

		const
			ob_type_small_char* ptr_small_char = (const ob_type_small_char*)(st->c_str());

		ob_type_size_t j;
		for (j = 0; j != l; ++j) {
			*datastream << ptr_small_char[j];
		}//for

	}

}//end namespace 

