
//Copyright (C) 1998-2018 MKTMK Moscow, Russia
//http://sourceforge.net/projects/obasic/
//http://mktmk.narod.ru
//e-mail: mktmk<at>yandex.ru
//e-mail: openbasicsoft<at>gmail.com
//interpreter Open Basic (OB).

#include <ob.h>

namespace OB_NAMESPACE_FOR_OB {

	//function for classes ob_var:: ob_float:: ob_int:: ob_str::

#define OB_BASEFUN(ob_class1,ident)                               \
ob_var* ob_class1::add_v(ob_var* a){return a->add_v(this);}       \
ob_var* ob_class1::sub_v(ob_var* a){return a->sub_v(this);}       \
ob_var* ob_class1::mul_v(ob_var* a){return a->mul_v(this);}       \
ob_var* ob_class1::div_v(ob_var* a){return a->div_v(this);}       \
ob_var* ob_class1::pww_v(ob_var* a){return a->pww_v(this);}       \
ob_var* ob_class1::asg_v(ob_var* a){return a->asg_v(this);}       \
bool    ob_class1::compare_v(const ob_var* a,                     \
ob_var::ob_type_if currentlexif) const {                          \
return a->compare_v(this,currentlexif);}                          \
ob_var* ob_class1::duplicate_v()                                  \
{ob_var* a=new ob_class1(var);return a;}                          \
ob_type_ident ob_class1::isA_v() const {return ident;}

#define OB_BASEFUNDIFFER(ob_class1)                                            \
ob_var* ob_class1::uniminus_v() {var=-var;return this;}                        \
bool ob_class1::eq_v() const {if(var==0) return true; else return false;}      \
void ob_class1::tostream_v(ob_ostream* out){                                   \
if(out==OB_NULL) OB_ERR(ob_err81)                                              \
if((!out->good())) OB_ERR(ob_err81)                                            \
out->putdigit(var);                                                            \
}                                                                              \
bool ob_class1::positive_v() const {if(var>0) return true; else return false;} 

	OB_BASEFUN(ob_float, OB_IDENTFLO);
	OB_BASEFUNDIFFER(ob_float);
	OB_BASEFUN(ob_int, OB_IDENTINT);
	OB_BASEFUNDIFFER(ob_int);
	OB_BASEFUN(ob_str, OB_IDENTSTR);

	ob_var* ob_str::uniminus_v() { OB_ERR(ob_err50); return OB_NULL; }
	bool ob_str::eq_v() const { OB_ERR(ob_err51); return 0; }
	bool ob_str::positive_v() const { OB_ERR(ob_err110); return 0; }

	void ob_str::tostream_v(ob_ostream* out) {
		if (out == OB_NULL) OB_ERR(ob_err81)
			if ((!out->good())) OB_ERR(ob_err81)

				ob_type_stringsize l = size_v();

		ob_type_stringsize i;
		for (i = 0; i != l; ++i) {
			out->put(var.c_str()[i]);
		}//for
	}

#define OB_DOPFUNCOMPARE(ob_class1,ob_class2)      \
bool ob_class1::compare_v(const ob_class2* a,      \
ob_var::ob_type_if currentlexif) const {           \
bool rez=false;                                    \
switch(currentlexif){                              \
case LESSIF:     if(a->var<var)  rez=true; break;  \
case GREATIF:    if(a->var>var)  rez=true; break;  \
case EQVIF:      if(a->var==var) rez=true; break;  \
case LESSEQVIF:  if(a->var<=var) rez=true; break;  \
case GREATEQVIF: if(a->var>=var) rez=true; break;  \
case NOTEQVIF:   if(a->var!=var) rez=true; break;  \
default:         OB_ERR(ob_err2);                  \
}                                                  \
return rez;                                        \
}

#define OB_DOPFUN(ob_class1,ob_class2)                                                         \
ob_var* ob_class1::add_v(ob_class2* a){a->var=(ob_class2::typedatavar)(a->var+var);return a;}  \
ob_var* ob_class1::sub_v(ob_class2* a){a->var=(ob_class2::typedatavar)(a->var-var);return a;}  \
ob_var* ob_class1::mul_v(ob_class2* a){a->var=(ob_class2::typedatavar)(a->var*var);return a;}  \
ob_var* ob_class1::div_v(ob_class2* a){a->var=(ob_class2::typedatavar)(a->var/var);return a;}  \
ob_var* ob_class1::asg_v(ob_class2* a){a->var=(ob_class2::typedatavar)(var);return a;}         \
OB_DOPFUNCOMPARE(ob_class1,ob_class2)

	OB_DOPFUN(ob_float, ob_float)
		ob_var* ob_float::pww_v(ob_float* a) { a->var = (ob_type_flo)OB_USER_POW((ob_type_pow)(a->var), (ob_type_pow)var); return a; }

	//OB_DOPFUN(ob_float,ob_int)     // to be change

	ob_var* ob_float::add_v(ob_int* a) { var = a->var + var; return this; }
	ob_var* ob_float::sub_v(ob_int* a) { var = a->var - var; return this; }
	ob_var* ob_float::mul_v(ob_int* a) { var = a->var*var; return this; }
	ob_var* ob_float::div_v(ob_int* a) { var = a->var / var; return this; }
	ob_var* ob_float::pww_v(ob_int* a) { var = (ob_type_flo)OB_USER_POW((ob_type_pow)(a->var), (ob_type_pow)var); return this; }
	ob_var* ob_float::asg_v(ob_int* a) { a->var = (ob_type_int)var; return a; }

	OB_DOPFUNCOMPARE(ob_float, ob_int)

		OB_DOPFUN(ob_int, ob_float)
		ob_var* ob_int::pww_v(ob_float* a) { a->var = (ob_type_flo)OB_USER_POW((ob_type_pow)(a->var), (ob_type_pow)var); return a; }

	OB_DOPFUN(ob_int, ob_int)
		ob_var* ob_int::pww_v(ob_int* a) { a->var = (ob_type_int)OB_USER_POW((ob_type_pow)(a->var), (ob_type_pow)var); return a; }

#define OB_DOPFUNONESTR(name,ob_class1,ob_class2)              \
ob_var* ob_class1::name(ob_class2*){OB_ERR(ob_err52);return OB_NULL;}

#define OB_DOPFUNONESTRCOMPARE(ob_class1,ob_class2)                    \
bool ob_class1::compare_v(const ob_class2*,ob_var::ob_type_if) const { \
OB_ERR(ob_err53);return 0;}

#define OB_DOPFUNSTR(ob_class1,ob_class2)         \
OB_DOPFUNONESTR(add_v,ob_class1,ob_class2)        \
OB_DOPFUNONESTR(sub_v,ob_class1,ob_class2)        \
OB_DOPFUNONESTR(mul_v,ob_class1,ob_class2)        \
OB_DOPFUNONESTR(div_v,ob_class1,ob_class2)        \
OB_DOPFUNONESTR(pww_v,ob_class1,ob_class2)        \
OB_DOPFUNONESTR(asg_v,ob_class1,ob_class2)        \
OB_DOPFUNONESTRCOMPARE(ob_class1,ob_class2)

	OB_DOPFUNSTR(ob_float, ob_str)
		OB_DOPFUNSTR(ob_int, ob_str)
		OB_DOPFUNSTR(ob_str, ob_float)
		OB_DOPFUNSTR(ob_str, ob_int)

		OB_DOPFUNCOMPARE(ob_str, ob_str)

		ob_var* ob_str::add_v(ob_str* a) {
		ob_type_string tmpstr(a->var.c_str(), a->var.getcount() - 1);
		tmpstr += var;
		a->var = tmpstr;
		return a;
	}

	ob_var* ob_str::asg_v(ob_str* a) { a->var = var; return a; }

	OB_DOPFUNONESTR(sub_v, ob_str, ob_str)
		OB_DOPFUNONESTR(mul_v, ob_str, ob_str)
		OB_DOPFUNONESTR(div_v, ob_str, ob_str)
		OB_DOPFUNONESTR(pww_v, ob_str, ob_str)

		//constructors
		ob_float::ob_float(ob_type_char* a) {
		var = ob_type_flo();
		ob_type_istrstream b(a);
		b >> var;
	}

	ob_int::ob_int(ob_type_char* a) {
		var = ob_type_int();
		ob_type_istrstream b(a);
		b >> var;
	}

	ob_float::ob_float(ob_type_flo a) :var(a) {}
	ob_int::ob_int(ob_type_int a) : var(a) {}
	ob_str::ob_str(ob_type_char* s, ob_type_stringsize l) : var(s, l) {}
	ob_str::ob_str(ob_type_char* s) : var(s) {}
	ob_str::ob_str(ob_type_string& s) : var(s) {};

	ob_float::ob_float() :var(ob_type_flo()) {}
	ob_int::ob_int() : var(ob_type_int()) {}
	ob_str::ob_str() : var((ob_type_char*)"") {}

	//topar
#define OB_TOPAR(ob_class1,offset,showget)                    \
void ob_class1::topar_v(ob_par* p,const ob_type_parnum i){    \
showget                                                       \
(p->mo)[offset][0]++;                                         \
(p->mo)[offset][(p->mo)[offset][0]]=i;                        \
}

	OB_TOPAR(ob_float, OB_TYPEFLO, (p->pf)[(p->mo)[OB_TYPEFLO][0]] = var;)
		OB_TOPAR(ob_int, OB_TYPEINT, (p->pi)[(p->mo)[OB_TYPEINT][0]] = var;)
		OB_TOPAR(ob_str, OB_TYPESTR, *(p->pc) << var.c_str() << ends;)

		//casts
		void ob_float::cast_v(ob_type_flo* a) { *a = var; }
	void ob_float::cast_v(ob_type_int* a) { *a = (ob_type_int)var; }
	void ob_float::cast_v(ob_type_char** a) { OB_ERR(ob_err73); *a = OB_NULL; }

	void ob_int::cast_v(ob_type_flo* a) { *a = (ob_type_flo)var; }
	void ob_int::cast_v(ob_type_int* a) { *a = var; }
	void ob_int::cast_v(ob_type_char** a) { OB_ERR(ob_err74); *a = OB_NULL; }

	void ob_str::cast_v(ob_type_flo* a) { OB_ERR(ob_err75); *a = ob_type_flo(); }
	void ob_str::cast_v(ob_type_int* a) { OB_ERR(ob_err76); *a = ob_type_int(); }
	void ob_str::cast_v(ob_type_char** a) { *a = var.c_str(); }

	ob_type_string* ob_float::getstring_v() { return OB_NULL; }
	ob_type_string* ob_int::getstring_v() { return OB_NULL; }
	ob_type_string* ob_str::getstring_v() { return &var; }

}//end namespace 
