
//Copyright (C) 1998-2018 MKTMK Moscow, Russia
//http://sourceforge.net/projects/obasic/
//http://mktmk.narod.ru
//e-mail: mktmk<at>yandex.ru
//e-mail: openbasicsoft<at>gmail.com
//interpreter Open Basic (OB).

#include <ob.h>

namespace OB_NAMESPACE_FOR_OB {

	//here is ob_lex::function

	ob_varbase* ob_lex::extractvarwithoutcreate() {

		ob_type_dim ptrdimcurrent;
		ob_varbase* varptr;

		ob_vararray*       nestedcurrentarray;

		switch (currentlex) {

		case ob_lex::OLDARRAY:
			nestedcurrentarray = currentarray;
			getsizearray(&ptrdimcurrent);
			nestedcurrentarray->setsize(&ptrdimcurrent);
			varptr = nestedcurrentarray;
			break;

		case ob_lex::OLDVARIABLE:
			varptr = currentvar;
			break;

		default:
			varptr = OB_NULL;
			break;
		}//switch
		return varptr;
	}

	ob_varbase* ob_lex::extractvar() {

		ob_varbase* varptr;

		if (currentlex == ob_lex::NEWNAME) {
			varptr = ptrbasic->get_common_table()->putvar(&currentlexasnamestatic, &in);
		}//if
		else {
			varptr = extractvarwithoutcreate();
		}//else

		return varptr;
	}

	void ob_lex::workvariable(ob_savewrapper* left) {

		ob_savewrapper right;

		get_lex();
		if (currentlex != ob_lex::ASSIGN) OB_ERR(ob_err8)
			get_lex();

		expr(&right);

		left->asg(&right);
	}

	void ob_lex::partostream(ob_type_ostrstream* name, ob_type_streampos one) {

		ob_type_streampos tp = in.getposition();
		ob_type_streampos tp1 = tp - (ob_type_streampos)sizeof(ob_type_char);

		ob_type_char ch;
		setposition(one);

		for (;;) {
			if (in.getposition() >= (tp1)) break;
			in.get(ch);
			*name << ch;
		}//for

		in.setposition(tp);
		*name << ends;
	}

}//end namespace 

