
//Copyright (C) 1998-2018 MKTMK Moscow, Russia
//http://sourceforge.net/projects/obasic/
//http://mktmk.narod.ru
//e-mail: mktmk<at>yandex.ru
//e-mail: openbasicsoft<at>gmail.com
//interpreter Open Basic (OB).

#include <ob.h>

namespace OB_NAMESPACE_FOR_OB {

	//function, build in ob_obasic in the beginning (with ob_api interface)

	//random
	OB_DECLARE_USER_FUNCTION(ob_fun_rnd, ob_type_flo) {
		ob_type_flo data = ((ob_type_flo)rand()) / ((ob_type_flo)RAND_MAX);
		if (basic_ptr&&parstring&&descrf&&descri&&descrc&&parf&&pari&&parc) return data;
		return data;
	}

	//signum
	OB_DECLARE_USER_FUNCTION(ob_fun_sgn, ob_type_int) {

		ob_type_flo data = 0;
		int ret;

		if (((descrf[0] + descri[0] + descrc[0]) != 1) || ((descrf[0] + descri[0]) != 1)) OB_ERR(ob_err23);

		if (descri[0] != 0) data = (ob_type_flo)pari[0];
		if (descrf[0] != 0) data = parf[0];

		if (data > 0)  ret = 1;
		else
			if (data == 0) ret = 0;
			else
				ret = -1;

		//for warning off
		if (basic_ptr&&parstring&&descrf&&descri&&descrc&&parf&&pari&&parc) return ret;
		return ret;
	}

	//len
	OB_DECLARE_USER_FUNCTION(ob_fun_len, ob_type_int) {
		if (descrc[0] != 0) return (ob_type_int)(ob_strlen((ob_type_char*)parc) - 1);
		if (basic_ptr&&parstring&&descrf&&descri&&descrc&&parf&&pari&&parc) OB_ERR(ob_err23);
		OB_ERR(ob_err23);
		return 0;
	}

	//time
	OB_DECLARE_USER_FUNCTION(ob_fun_time, ob_type_int) {
		time_t tret = time(OB_NULL);
		if (basic_ptr != OB_NULL) return (ob_type_int)tret;
		if (basic_ptr&&parstring&&descrf&&descri&&descrc&&parf&&pari&&parc) OB_ERR(ob_err23);
		OB_ERR(ob_err23);
		return 0;
	}

	//ob_fun_digit2str
	OB_DECLARE_USER_FUNCTION(ob_fun_digit2str, ob_type_char*) {

		ob_type_ostrstream os;

		if (descrf[0] != 0) {
			os << parf[0];
		}//if
		else {
			if (descri[0] != 0) {
				os << pari[0];
			}//if
		}//else

		ob_type_char* p = new ob_type_char[os.str().length() + 1];

		ob_strcpy(p, os.str().c_str());

		if (basic_ptr&&parstring&&descrf&&descri&&descrc&&parf&&pari&&parc) return p;
		return p;
	}

	//ob_fun_digit2hexstr
	OB_DECLARE_USER_FUNCTION(ob_fun_digit2hexstr, ob_type_char*) {

		ob_type_ostrstream os;

		if (descri[0] != 0) {
			os << hex << "0x" << pari[0];
		}//if

		ob_type_char* p = new ob_type_char[os.str().length() + 1];

		ob_strcpy(p, os.str().c_str());

		if (basic_ptr&&parstring&&descrf&&descri&&descrc&&parf&&pari&&parc) return p;
		return p;
	}

	OB_DECLARE_USER_FUNCTION(ob_get_obasic_version, ob_type_int) {
		ob_type_int ret = (ob_type_int)basic_ptr->version();
		if (basic_ptr&&parstring&&descrf&&descri&&descrc&&parf&&pari&&parc) return ret;
		return ret;
	}

	ob_type_istreamcommon* ob_get_istreamcommon_for_userfun(ob_obasic* basic_ptr, ob_type_char* name) {

		ob_type_istreamcommon* istrptr;
		bool name_type = basic_ptr->local_name_detect(name);

		if (name_type == false) {
			istrptr = OB_NULL;
		}
		else {
			istrptr = basic_ptr->get_current_input_stream();
		}

		return istrptr;
	}

	OB_DECLARE_USER_FUNCTION(ob_create_array_or_var, ob_type_int) {

		ob_type_int ret = 0;

		if (descrc[0] == 1) {

			ob_type_char* name = (ob_type_char*)ob_getstringparam(descrc, parc, 0);
			ob_type_istreamcommon* istrptr = ob_get_istreamcommon_for_userfun(basic_ptr, name);

			if (descri[0] == 0) {
				//create var
				basic_ptr->createvar(name, istrptr);
				ret = 1;
			}
			else {
				//create array
				ob_type_arraydimension kr = descri[0];
				ob_common_array<ob_type_arraysize, ob_type_arraydimension> as(kr);

				ob_type_arraysize* as1 = as.getdata();

				ret = 1;
				ob_type_arraydimension i;
				for (i = ob_type_arraydimension(); i != kr; ++i) {
					ob_type_int val = pari[i];
					if (val <= 0) val = 1;
					as1[i] = val;
					ret *= val;
				}

				basic_ptr->createarray(name, kr, as1, istrptr);
			}
		}
		else {

			if (descrc[0] == 2) {
				//create array

				ob_type_char* name = (ob_type_char*)ob_getstringparam(descrc, parc, 0);
				ob_type_char* name1 = (ob_type_char*)ob_getstringparam(descrc, parc, 1);

				ob_type_istreamcommon* istrptr = ob_get_istreamcommon_for_userfun(basic_ptr, name);
				ob_type_istreamcommon* istrptr1 = ob_get_istreamcommon_for_userfun(basic_ptr, name1);

				ob_type_ident array_id_var = basic_ptr->typevar(name1, istrptr1);
				ob_type_ident array_id_array = basic_ptr->typearray(name1, istrptr1);

				if (array_id_var == OB_IDENTINT) {

					ob_type_int val;
					if (basic_ptr->readvar(name1, &val, OB_NULL, istrptr1) == false) OB_ERR(ob_err23);

					if (val <= 0) val = 1;

					ob_type_arraydimension kr1 = 1;
					ob_type_arraysize as2 = val;
					basic_ptr->createarray(name, kr1, &as2, istrptr);

					ret = val;
				}
				else {

					if (array_id_array == OB_IDENTINT) {

						ob_type_arraydimension kr;
						const ob_type_arraysize* as = basic_ptr->getarraysize(name1, &kr, istrptr1);

						if (kr == 1) {

							ob_type_arraydimension kr1 = as[0];
							ob_common_array<ob_type_arraysize, ob_type_arraydimension> as1(kr1);

							ob_type_arraysize* as2 = as1.getdata();

							ret = 1;
							ob_type_arraydimension i;
							for (i = ob_type_arraydimension(); i != kr1; ++i) {
								ob_type_arraysize as_read = i + 1;
								ob_type_int val;
								if (basic_ptr->readvar(name1, &val, &as_read, istrptr1) == false) OB_ERR(ob_err23);
								if (val <= 0) val = 1;
								as2[i] = val;
								ret *= val;
							}
							basic_ptr->createarray(name, kr1, as2, istrptr);
						}
					}
				}
			}
		}

		if (basic_ptr&&parstring&&descrf&&descri&&descrc&&parf&&pari&&parc) return ret;
		return ret;
	}

	OB_DECLARE_USER_FUNCTION(ob_get_size_array, ob_type_int) {

		ob_type_int ret = 0;

		if ((descrc[0] != 0) && (descri[0] != 0)) {

			ob_type_char* name = (ob_type_char*)ob_getstringparam(descrc, parc, 0);
			ob_type_istreamcommon* istrptr = ob_get_istreamcommon_for_userfun(basic_ptr, name);

			ob_type_ident array_id = basic_ptr->typearray(name, istrptr);

			if (array_id != OB_NOIDENT) {

				ob_type_arraydimension kr;
				const ob_type_arraysize* as = basic_ptr->getarraysize(name, &kr, istrptr);

				if (as != OB_NULL) {
					ob_type_arraydimension a = (ob_type_arraydimension)pari[0];
					if (a < 0) a = 0;

					if (a == 0) {
						ret = kr;
					}
					else {
						if (a <= kr) ret = as[a - 1];
					}
				}
			}
		}
		if (basic_ptr&&parstring&&descrf&&descri&&descrc&&parf&&pari&&parc) return ret;
		return ret;
	}

	void ob_array_var_access(
		ob_obasic* basic_ptr,
		ob_type_char* namedst,
		ob_type_char* namesrc,
		ob_type_arraysize* as_dst,
		ob_type_arraysize* as_src,
		ob_type_istreamcommon* istrptr_dst,
		ob_type_istreamcommon* istrptr_src,
		ob_type_ident ti
	) {

		ob_type_flo   h1;
		ob_type_int   h2;

		if (ti != OB_NOIDENT) {

			switch (ti) {

			case OB_IDENTFLO:
				if (basic_ptr->readvar(namesrc, &h1, as_src, istrptr_src) == false) OB_ERR(ob_err23);
				if (basic_ptr->writevar(namedst, h1, as_dst, istrptr_dst) == false) OB_ERR(ob_err23);
				break;

			case OB_IDENTINT:
				if (basic_ptr->readvar(namesrc, &h2, as_src, istrptr_src) == false) OB_ERR(ob_err23);
				if (basic_ptr->writevar(namedst, h2, as_dst, istrptr_dst) == false) OB_ERR(ob_err23);
				break;

			case OB_IDENTSTR:
				ob_type_stringsize len;

				basic_ptr->strlenvar(namesrc, &len, as_src, istrptr_src);

				ob_common_array<ob_type_char, ob_type_stringsize> buf(len + 1);

				if (basic_ptr->readvar(namesrc, buf.getdata(), as_src, istrptr_src) == false) OB_ERR(ob_err23);
				if (basic_ptr->writevar(namedst, buf.getdata(), as_dst, istrptr_dst) == false) OB_ERR(ob_err23);

				break;

			}//switch
		}
	}

	OB_DECLARE_USER_FUNCTION(ob_copy_array, ob_type_int) {
		ob_type_int ret = 0;

		if (descrc[0] >= 2) {

			ob_type_char* namedst = (ob_type_char*)ob_getstringparam(descrc, parc, 0);
			ob_type_char* namesrc = (ob_type_char*)ob_getstringparam(descrc, parc, 1);

			ob_type_istreamcommon* istrptr_src = ob_get_istreamcommon_for_userfun(basic_ptr, namesrc);

			ob_type_ident ti = basic_ptr->typearray(namesrc, istrptr_src);

			if (ti != OB_NOIDENT) {

				ob_type_istreamcommon* istrptr_dst = ob_get_istreamcommon_for_userfun(basic_ptr, namedst);

				ob_type_arraydimension kr;
				const ob_type_arraysize* as0 = basic_ptr->getarraysize(namesrc, &kr, istrptr_src);

				ob_common_array<ob_type_arraysize, ob_type_arraydimension> as(kr);

				ob_type_arraydimension i;
				for (i = 0; i != kr; ++i) {
					as.getdata()[i] = 1;
				}//for

				basic_ptr->createarray(namedst, kr, (ob_type_arraysize*)as0, istrptr_dst);

				for (;;) {

					ob_array_var_access(basic_ptr, namedst, namesrc, as.getdata(), as.getdata(), istrptr_dst, istrptr_src, ti);

					ob_type_arraydimension stopcount = 0;

					for (i = 0; i != kr; ++i) {

						++as.getdata()[i];

						if (as.getdata()[i] == (as0[i] + 1)) {
							as.getdata()[i] = 1;
							++stopcount;
							continue;
						}//if
						else {
							break;
						}//else

					}//for

					if (stopcount == kr) break;
				}//for

			}//if

			ret = 1;
		}//if

		if (basic_ptr&&parstring&&descrf&&descri&&descrc&&parf&&pari&&parc) return ret;
		return ret;
	}

	OB_DECLARE_USER_FUNCTION(ob_get_type_array_or_var, ob_type_int) {

		ob_type_int ret = -1;
		ob_type_ident ti = OB_NOIDENT;

		if (descrc[0] != 0) {

			ob_type_char* namesrc = (ob_type_char*)ob_getstringparam(descrc, parc, 0);
			ob_type_istreamcommon* istrptr_src = ob_get_istreamcommon_for_userfun(basic_ptr, namesrc);

			ti = basic_ptr->typevar(namesrc, istrptr_src);
			if (ti == OB_NOIDENT) ti = basic_ptr->typearray(namesrc, istrptr_src);

			ret = (ob_type_int)ti;
		}

		if (basic_ptr&&parstring&&descrf&&descri&&descrc&&parf&&pari&&parc) return ret;
		return ret;
	}

	OB_DECLARE_USER_FUNCTION(ob_get_first_array_iteration, ob_type_int) {

		ob_type_int ret = 0;

		if (descrc[0] >= 2) {

			ob_type_char* name = (ob_type_char*)ob_getstringparam(descrc, parc, 0);
			ob_type_istreamcommon* istrptr = ob_get_istreamcommon_for_userfun(basic_ptr, name);

			ob_type_ident ti = basic_ptr->typearray(name, istrptr);

			if (ti != OB_NOIDENT) {

				ob_type_char* name1 = (ob_type_char*)ob_getstringparam(descrc, parc, 1);
				ob_type_istreamcommon* istrptr1 = ob_get_istreamcommon_for_userfun(basic_ptr, name1);

				ob_type_arraydimension kr;
				const ob_type_arraysize* as = basic_ptr->getarraysize(name, &kr, istrptr);

				ob_type_arraydimension kr1 = 1;
				ob_type_arraysize as1 = kr;

				basic_ptr->createarray(name1, kr1, &as1, istrptr1);
				ob_type_ident ti1 = basic_ptr->typearray(name1, istrptr1);

				if (ti1 == OB_IDENTINT) {

					ob_type_int val = 1;
					ob_type_arraydimension i;
					for (i = ob_type_arraydimension(); i != kr; ++i) {
						ob_type_arraysize as_read = i + 1;
						if (basic_ptr->writevar(name1, val, &as_read, istrptr1) == false) OB_ERR(ob_err23);
					}

					ret = 1;
				}
			}
		}

		if (basic_ptr&&parstring&&descrf&&descri&&descrc&&parf&&pari&&parc) return ret;
		return ret;
	}

	OB_DECLARE_USER_FUNCTION(ob_get_next_array_iteration, ob_type_int) {

		ob_type_int ret = 0;

		if (descrc[0] >= 2) {

			ob_type_char* name = (ob_type_char*)ob_getstringparam(descrc, parc, 0);
			ob_type_istreamcommon* istrptr = ob_get_istreamcommon_for_userfun(basic_ptr, name);

			ob_type_ident ti = basic_ptr->typearray(name, istrptr);

			if (ti != OB_NOIDENT) {

				ob_type_char* name1 = (ob_type_char*)ob_getstringparam(descrc, parc, 1);
				ob_type_istreamcommon* istrptr1 = ob_get_istreamcommon_for_userfun(basic_ptr, name1);

				ob_type_ident ti1 = basic_ptr->typearray(name1, istrptr1);

				if (ti1 == OB_IDENTINT) {

					ob_type_arraydimension kr;
					const ob_type_arraysize* as = basic_ptr->getarraysize(name, &kr, istrptr);

					ob_type_arraydimension kr1;
					const ob_type_arraysize* as1 = basic_ptr->getarraysize(name1, &kr1, istrptr1);

					if (kr1 == 1) {

						if (as1[0] == kr) {

							ob_common_array<ob_type_arraysize, ob_type_arraydimension> as2(kr);
							ob_type_arraysize* as3 = as2.getdata();

							ob_type_int val;
							ob_type_arraydimension j;
							ob_type_arraydimension i;
							for (i = ob_type_arraydimension(); i != kr; ++i) {
								ob_type_arraysize as_read = i + 1;
								if (basic_ptr->readvar(name1, &val, &as_read, istrptr1) == false) OB_ERR(ob_err23);
								as3[i] = val;
							}

							for (;;) {

								ob_type_arraydimension stopcount = 0;

								for (j = ob_type_arraydimension(); j != kr; ++j) {

									i = kr - j - 1;

									++as3[i];

									if (as3[i] == (as[i] + 1)) {
										as3[i] = 1;
										++stopcount;
										continue;
									}
									else {
										break;
									}
								}

								if (stopcount == kr) {
									ret = 2;
									break;
								}
								else {
									ret = 1;
									break;
								}
							}

							for (i = ob_type_arraydimension(); i != kr; ++i) {
								ob_type_arraysize as_read = i + 1;
								val = as3[i];
								if (basic_ptr->writevar(name1, val, &as_read, istrptr1) == false) OB_ERR(ob_err23);
							}
						}
					}
				}
			}
		}

		if (basic_ptr&&parstring&&descrf&&descri&&descrc&&parf&&pari&&parc) return ret;
		return ret;
	}

	OB_DECLARE_USER_FUNCTION(ob_assign_array_var, ob_type_int) {

		ob_type_int ret = -1;
		ob_type_ident tiret = OB_NOIDENT;

		if (descrc[0] == 2) {

			ob_type_char* namedst = (ob_type_char*)ob_getstringparam(descrc, parc, 0);
			ob_type_char* namesrc = (ob_type_char*)ob_getstringparam(descrc, parc, 1);

			ob_type_istreamcommon* istrptr_dst = ob_get_istreamcommon_for_userfun(basic_ptr, namedst);
			ob_type_istreamcommon* istrptr_src = ob_get_istreamcommon_for_userfun(basic_ptr, namesrc);

			ob_type_ident ti_src_var = basic_ptr->typevar(namesrc, istrptr_src);
			ob_type_ident ti_dst_var = basic_ptr->typevar(namedst, istrptr_dst);

			ob_type_ident ti_src_array = basic_ptr->typearray(namesrc, istrptr_src);
			ob_type_ident ti_dst_array = basic_ptr->typearray(namedst, istrptr_dst);

			if (descri[0] == 0) {
				//read/write var
				if (ti_src_var != OB_NOIDENT) {
					if (ti_dst_var != OB_NOIDENT) {
						ob_array_var_access(basic_ptr, namedst, namesrc, OB_NULL, OB_NULL, istrptr_dst, istrptr_src, ti_src_var);
						tiret = ti_src_var;
					}
				}
			}
			else {
				//read/write array element
				ob_type_arraydimension kr = descri[0];
				ob_common_array<ob_type_arraysize, ob_type_arraydimension> as(kr);

				ob_type_arraysize* as1 = as.getdata();

				ob_type_arraydimension i;
				for (i = ob_type_arraydimension(); i != kr; ++i) {
					ob_type_int val = pari[i];
					if (val <= 0) val = 1;
					as1[i] = val;
				}

				if (ti_src_var != OB_NOIDENT) {
					if (ti_dst_array != OB_NOIDENT) {
						ob_array_var_access(basic_ptr, namedst, namesrc, as1, OB_NULL, istrptr_dst, istrptr_src, ti_src_var);
						tiret = ti_src_var;
					}
				}
				else {

					if (ti_src_array != OB_NOIDENT) {
						if (ti_dst_var != OB_NOIDENT) {
							ob_array_var_access(basic_ptr, namedst, namesrc, OB_NULL, as1, istrptr_dst, istrptr_src, ti_src_array);
							tiret = ti_src_array;
						}
					}
				}
			}
		}
		else {

			if (descrc[0] == 3) {
				//read/write array element

				ob_type_char* namedst = (ob_type_char*)ob_getstringparam(descrc, parc, 0);
				ob_type_char* namesrc = (ob_type_char*)ob_getstringparam(descrc, parc, 1);
				ob_type_char* name1 = (ob_type_char*)ob_getstringparam(descrc, parc, 2);

				ob_type_istreamcommon* istrptr_dst = ob_get_istreamcommon_for_userfun(basic_ptr, namedst);
				ob_type_istreamcommon* istrptr_src = ob_get_istreamcommon_for_userfun(basic_ptr, namesrc);
				ob_type_istreamcommon* istrptr1 = ob_get_istreamcommon_for_userfun(basic_ptr, name1);

				ob_type_ident ti_src_var = basic_ptr->typevar(namesrc, istrptr_src);
				ob_type_ident ti_dst_var = basic_ptr->typevar(namedst, istrptr_dst);

				ob_type_ident ti_src_array = basic_ptr->typearray(namesrc, istrptr_src);
				ob_type_ident ti_dst_array = basic_ptr->typearray(namedst, istrptr_dst);

				ob_type_ident array_id = basic_ptr->typearray(name1, istrptr1);

				if (array_id == OB_IDENTINT) {

					ob_type_arraydimension kr;
					const ob_type_arraysize* as = basic_ptr->getarraysize(name1, &kr, istrptr1);

					if (kr == 1) {

						ob_type_arraydimension kr1 = as[0];
						ob_common_array<ob_type_arraysize, ob_type_arraydimension> as1(kr1);

						ob_type_arraysize* as2 = as1.getdata();

						ob_type_arraydimension i;
						for (i = ob_type_arraydimension(); i != kr1; ++i) {
							ob_type_arraysize as_read = i + 1;
							ob_type_int val;
							if (basic_ptr->readvar(name1, &val, &as_read, istrptr1) == false) OB_ERR(ob_err23);
							if (val <= 0) val = 1;
							as2[i] = val;
						}

						if (ti_src_var != OB_NOIDENT) {
							if (ti_dst_array != OB_NOIDENT) {
								ob_array_var_access(basic_ptr, namedst, namesrc, as2, OB_NULL, istrptr_dst, istrptr_src, ti_src_var);
								tiret = ti_src_var;
							}
						}
						else {

							if (ti_src_array != OB_NOIDENT) {
								if (ti_dst_var != OB_NOIDENT) {
									ob_array_var_access(basic_ptr, namedst, namesrc, OB_NULL, as2, istrptr_dst, istrptr_src, ti_src_array);
									tiret = ti_src_array;
								}
							}
						}
					}
				}
			}
		}

		ret = (ob_type_int)tiret;

		if (basic_ptr&&parstring&&descrf&&descri&&descrc&&parf&&pari&&parc) return ret;
		return ret;
	}

	OB_DECLARE_USER_FUNCTION(ob_fun_fabs, ob_type_flo) { return ob_call_fun_with_one_parameter<ob_type_flo, &fabs>(basic_ptr, parstring, descrf, descri, descrc, parf, pari, parc); }
	OB_DECLARE_USER_FUNCTION(ob_fun_sin, ob_type_flo) { return ob_call_fun_with_one_parameter<ob_type_flo, &sin>(basic_ptr, parstring, descrf, descri, descrc, parf, pari, parc); }
	OB_DECLARE_USER_FUNCTION(ob_fun_cos, ob_type_flo) { return ob_call_fun_with_one_parameter<ob_type_flo, &cos>(basic_ptr, parstring, descrf, descri, descrc, parf, pari, parc); }
	OB_DECLARE_USER_FUNCTION(ob_fun_atan, ob_type_flo) { return ob_call_fun_with_one_parameter<ob_type_flo, &atan>(basic_ptr, parstring, descrf, descri, descrc, parf, pari, parc); }
	OB_DECLARE_USER_FUNCTION(ob_fun_sqrt, ob_type_flo) { return ob_call_fun_with_one_parameter<ob_type_flo, &sqrt>(basic_ptr, parstring, descrf, descri, descrc, parf, pari, parc); }
	OB_DECLARE_USER_FUNCTION(ob_fun_exp, ob_type_flo) { return ob_call_fun_with_one_parameter<ob_type_flo, &exp>(basic_ptr, parstring, descrf, descri, descrc, parf, pari, parc); }
	OB_DECLARE_USER_FUNCTION(ob_fun_log, ob_type_flo) { return ob_call_fun_with_one_parameter<ob_type_flo, &log>(basic_ptr, parstring, descrf, descri, descrc, parf, pari, parc); }
	OB_DECLARE_USER_FUNCTION(ob_fun_log10, ob_type_flo) { return ob_call_fun_with_one_parameter<ob_type_flo, &log10>(basic_ptr, parstring, descrf, descri, descrc, parf, pari, parc); }

	OB_DECLARE_USER_FUNCTION(ob_fun_str2float, ob_type_flo) { return ob_fun_convert_str2int_flo<ob_type_flo>(basic_ptr, parstring, descrf, descri, descrc, parf, pari, parc); }
	OB_DECLARE_USER_FUNCTION(ob_fun_str2int, ob_type_int) { return ob_fun_convert_str2int_flo<ob_type_int>(basic_ptr, parstring, descrf, descri, descrc, parf, pari, parc); }
	OB_DECLARE_USER_FUNCTION(ob_fun_ceil, ob_type_int) { return ob_call_fun_with_one_parameter<ob_type_int, &ceil>(basic_ptr, parstring, descrf, descri, descrc, parf, pari, parc); }

#ifdef _MSC_VER

	void ob_get_struct_tm(time_t* tt, struct tm* t) {
		localtime_s(t, tt);
	}

#else

	void ob_get_struct_tm(time_t* tt, struct tm* t) {
		*t = *localtime(tt);
	}

#endif

	//clk
	OB_DECLARE_USER_FUNCTION(ob_fun_clk, ob_type_char*) {

		time_t tt = time(OB_NULL);

		struct tm t;

		ob_get_struct_tm(&tt,&t);

		ob_type_ostrstream os;

		os << t.tm_hour << ":" << t.tm_min << ":" << t.tm_sec;

		ob_type_char* p = new ob_type_char[os.str().length() + 1];

		ob_strcpy(p, os.str().c_str());

		if (basic_ptr&&parstring&&descrf&&descri&&descrc&&parf&&pari&&parc) return p;
		return p;
	}

	//data
	OB_DECLARE_USER_FUNCTION(ob_fun_dat, ob_type_char*) {

		time_t tt = time(OB_NULL);

		struct tm d;

		ob_get_struct_tm(&tt, &d);

		ob_type_ostrstream os;

		os << (d.tm_mon + 1) << "-" << d.tm_mday << "-" << (d.tm_year + 1900);

		ob_type_char* p = new ob_type_char[os.str().length() + 1];

		ob_strcpy(p, os.str().c_str());

		if (basic_ptr&&parstring&&descrf&&descri&&descrc&&parf&&pari&&parc) return p;
		return p;
	};


}//end namespace 
